image: docker:latest

before_script:
- export VERSION="${CI_COMMIT_TAG:-$CI_COMMIT_REF_SLUG}"
- export IMAGE="${CI_REGISTRY_IMAGE}:${VERSION}"
- export STACK="recaleur"

stages:
- build
- deploy

build:
  stage: build
  script:
  - docker login -u gitlab-ci-token -p $CI_JOB_TOKEN $CI_REGISTRY
  - docker build -t ${IMAGE} .
  - docker push ${IMAGE}
  coverage: '/coverage: \d+\.\d+% of statements/'

codeclimate:
  stage: build
  script:
    - docker pull codeclimate/codeclimate
    - docker run -e CODECLIMATE_CODE="$(pwd)" -v "$(pwd)":/code -v /var/run/docker.sock:/var/run/docker.sock -v /tmp/cc:/tmp/cc codeclimate/codeclimate engines:install
    - docker run -e CODECLIMATE_CODE="$(pwd)" -v "$(pwd)":/code -v /var/run/docker.sock:/var/run/docker.sock -v /tmp/cc:/tmp/cc codeclimate/codeclimate analyze -f json > codeclimate.json
  artifacts:
    paths: [codeclimate.json]

deploy review:
  image: registry.gitlab.com/recalbox/ops/rancher-cli:0.6.2
  stage: deploy
  variables:
    RECALEUR_RESPONSE: test
    RECALEUR_CANARY: 256
  script:
  - rancher rm ${STACK}/${CI_ENVIRONMENT_SLUG} || true
  - sed "s/RANCHER_SERVICENAME/${CI_ENVIRONMENT_SLUG}/" -i docker-compose.yml rancher-compose.yml
  - FQDN=${CI_ENVIRONMENT_SLUG}-recaleur-prod.recalbox.com rancher up -d --pull -u --force-upgrade -s ${STACK}
  environment:
    name: review/${CI_COMMIT_REF_SLUG}
    url: https://${CI_ENVIRONMENT_SLUG}-recaleur-prod.recalbox.com
    on_stop: clean review

clean review:
  image: registry.gitlab.com/recalbox/ops/rancher-cli:0.6.2
  stage: deploy
  when: manual
  dependencies: []
  script:
    - echo "cleaning ${IMAGE} from ${STACK}/${CI_ENVIRONMENT_SLUG}"
    - rancher rm ${STACK}/${CI_ENVIRONMENT_SLUG}
  environment:
    name: review/${CI_COMMIT_REF_SLUG}
    action: stop
